import importlib
import logging
import sys
from . import addon_updater_ops
import bpy

bl_info = {
    "name": "QuickSnap",
    "author": "Julien Heijmans",
    "blender": (2, 93, 0),
    'version': (1, 4, 7),
    "category": "3D View",
    "description": "Quickly snap objects/vertices/curve points",
    "warning": "",
    "doc_url": "https://github.com/JulienHeijmans/quicksnap",
    "releases_url": "https://github.com/JulienHeijmans/quicksnap/releases",
    "tracker_url": "https://github.com/JulienHeijmans/quicksnap/issues",
}

# Updating module names to use the new namespace format
modulesNames = ['addon_updater', 'addon_updater_ops', 'quicksnap_utils', 'quicksnap_snapdata', 'quicksnap_render',
                'quicksnap']

modulesFullNames = {}
for currentModuleName in modulesNames:
    modulesFullNames[currentModuleName] = ('{}.{}'.format(__package__, currentModuleName))

for currentModuleFullName in modulesFullNames.values():
    if currentModuleFullName in sys.modules:
        importlib.reload(sys.modules[currentModuleFullName])
    else:
        globals()[currentModuleFullName] = importlib.import_module(currentModuleFullName)
        setattr(globals()[currentModuleFullName], 'modulesNames', modulesFullNames)

def register():
    for current_module_name in modulesFullNames.values():
        if current_module_name in sys.modules:
            if hasattr(sys.modules[current_module_name], 'register'):
                if current_module_name == f"{__package__}.addon_updater_ops":
                    sys.modules[current_module_name].register(__package__)
                else:
                    sys.modules[current_module_name].register()

def unregister():
    for current_module_name in modulesFullNames.values():
        if current_module_name in sys.modules:
            if hasattr(sys.modules[current_module_name], 'unregister'):
                sys.modules[current_module_name].unregister()

class QuickSnapPreferences(bpy.types.AddonPreferences):
    bl_idname = __package__
    # Add your preferences properties here

    def draw(self, context):
        layout = self.layout
        # Add your preferences UI here

logger = logging.getLogger(__name__)
logger.handlers = []
logger.setLevel(logging.NOTSET)
console_handler = logging.StreamHandler()
console_handler.setFormatter(fmt=logging.Formatter('[%(levelname)s] %(asctime)s %(message)s'))
logger.addHandler(console_handler)
